# -*- coding: utf-8 -*-
# actor.py
# author: Gerd Doeben-Henisch
# Collection of functions to support simple actors

PID="ACC:\n "
        
class ACTOBJ:
    """This is a first sketch for an actor class. It has to be developed further """
    
    type = 'actor'
    inpMsg =''      #Message from the environment
    OutMsg = ''     #Message to the environment
    intake = 0      #Energy Offer with food
    behavefct = 0   #Type of behavior function {0,1,2}
    behavefctMax = 2 #Actual upper limit
    
    
    def __init__(self,name,time,x,y,dir,color, energy,energyrate):
        self.name = name
        self.time = time
        self.position = (x,y)
        self.dir = dir
        self.color = color
        self.energy = energy
        self.energyrate = energyrate
        
    def getName(self):
        return self.name
    
    def setName(self,name):
        #This should be a short name different from others; a number 
        # is enough ...         
        self.name = name
        
    def getTime(self):
        return self.time
    
    def setTime(self,time):
        #The time will be derived  from the environment time
         self.time = time

    def getPos(self):
        # This is the position in the data array with simple (x,y) coordinates
        return self.position

    def setPos(self,x,y):
        # This is the position in the data array with simple (x,y) coordinates
        # The array counts from 0 ... n-1
        # The user counts from 1 ... n
         self.position = (x,y)
    
    def setDir(self,dir):
        # There are four basic directions as {1,2,3,4}
        self.dir = dir
        
    def getDir(self):
        # There are four basic directions as {1,2,3,4}
        return self.dir 
         
    def getColor(self):
        # All actors have the color red (for now; perhaps more later)
        return self.color
    
    
    def setColor(self,incolor):
         # All actors have the color red (for now; perhaps more later)
         self.color = incolor
    
    def setEnergy(self,energy):
        # Show actual energy level
        self.energy = energy
    
    def getEnergy(self):
        # Show actual energy level
        return self.energy
    
    def setEnergyRate(self,energyrate):
        # Show actual energy level
        self.energyrate = energyrate
    
    def getEnergyRate(self):
        # Show actual energy level
        return self.energyrate    

    def setOutputMessage(self,outputMessage):
        #Some message to the environment
        self.OutMsg=outputMessage
        
    def getOutputMessage(self):
        return  self.OutMsg
    
    def setInputMessage(self,inputMessage):
        #Some message to the environment
        self.inpMsg=inputMessage
        
    def getInputMessage(self):
        return  self.inpMsg
    
    def setIntake(self,intake):
        #Some message from the environment to the actor
        self.intake=intake
        
    def getIntake(self):
        return  self.intake  
    
    def setBehavior(self,behavior):
        #Number 0 ore higher
        #Some message from the environment to the actor
        self.behavefct=behavior
        
    def getBehavior(self):
        return  self.behavefct 
    

    
    
def behaviorAcEmpty(e,a,win,winC,txt):
    
    import numpy as np
    import environment as env
    import acctor as acc
    import graphics as grph
    import control as ctrl
    
    #BODY PART
    # Compute time since last call and change energy level
    
    name = a.getName()
    
    #check for food-intake
    #REMARK: Food will only be detected if the manual pointer points
    #directly onto the food!!!
    
    f = a.getIntake()
    if f > 0:
        eold = a.getEnergy()
        enew = eold + f
        a.setEnergy(enew)
        a.setIntake(0)      #Set value back to zero
        print(PID+'Actor ',name,' has  increased ENERGYLEVEL = ',enew)
    
    #Check for new tme
    
    t1 = a.getTime()
    t2 = e.getClock()
    erate = a.getEnergyRate()
    ener = a.getEnergy()
    
    dt = t2-t1
    energynew = ener - (erate * dt)
    a.setEnergy(energynew)
    
    print(PID+'Actor ',name,' has new energy level = ',energynew)
    
    #MENTAL PART
    # Determine the new direction
    
    #Free space of preceding select ,essage
    ctrl.ctrlWinDel(txt)
    
    #Let the user click on a cell beside the actual position and determine
    # the direction
    
    txt6 = ctrl.ctrlWinLoc(winC)

    # Get and draw the coordinate of a point
    pdir = win.getMouse()
    xc=pdir.getX()
    yc=pdir.getY()
    print(PID+'P for new direction ',pdir,(xc,yc))
    
    
   #Transform the window coordinates into the array coordinates
    xs = int(xc/100)
    ys = int(yc/100) 
    x = xs+1
    y=ys+1
    print(PID+'P for new direction in Array  ',(x,y))
    
    #Delete message for pointing
    ctrl.ctrlWinDel(txt6)
   
   #compute the resulting direction rDir
   #Getting the old position
   
    p=a.getPos()
    print(PID+'Old Position of Actor = ',p)
    xold=p[0]
    yold=p[1]
    
    if xold ==  x:
        print(PID+'xold = x points to dir 1,3')
        if yold < y:
            dirnew = 3
            print(PID+'dir = ',dirnew,(xold,yold),(x,y))
        else:
            dirnew = 1
            print(PID+'dir = ',dirnew,(xold,yold),(x,y))
            
    elif yold == y:
        print(PID+' yold = y points to dir 2,4')
        if xold < x:
            dirnew = 2
            print(PID+'dir = ',dirnew,(xold,yold),(x,y))
        else:
            dirnew = 4
            print(PID+'dir = ',dirnew,(xold,yold),(x,y))
    else:
        print(PID+'ERROR with DIRECTION !!!')
        dirnew = a.getDir()
        print(PID+'Error Dirnew ',dirnew)
    
    a.setDir(dirnew)
    print(PID+'New direction of actor ',name, ' is = ',dirnew)
    
    a.setOutputMessage('yesMove')
    print(PID+'actor ',name, 'wants to move')
    
    

def behaviorActFix(e,a):
    """This defines the behavior which is 'fixed', that means that the actor will always change his direction in a definite manner. In this case here we have a 'right-handed' actor who changes his direction only, if he hits an obstacle, and then he is turining 90 degree to the 'right' """
    
    import numpy as np
    import environment as env
    import acctor as acc
    import math
    
    name = a.getName()
    
    #BODY PART
    #INTAKTE OF FOOD IF AVAILABLE
    
    f = a.getIntake()
    if f > 0:
        eold = a.getEnergy()
        enew = eold + f
        a.setEnergy(enew)
        a.setIntake(0)      #Set value back to zero
        print(PID+'Actor ',name,' has  increased ENERGYLEVEL = ',enew)
        
    # Compute time since last call and change energy level
    
    t1 = a.getTime()
    t2 = e.getClock()
    erate = a.getEnergyRate()
    ener = a.getEnergy()
    
    dt = t2-t1
    energynew = ener - (erate * dt)
    a.setEnergy(energynew)
    
    print(PID+'Actor ',name,' has new energy level = ',energynew)
    
    #MENTAL PART
    #Determining the new direction
    
    dirnew = a.getDir()
    
    #Checking for feedback. If 'NoMove' then change direction
    
    f = a.getInputMessage()
    print(PID+'Input Message from ENV  ',f)
    
    if f == "NoMove":
        print(PID+'Identification of -NoMove- happened')
        dirold = a.getDir()
        dirnew = dirold + 1
        if dirnew > 4:
            dirnew = dirnew % 4
            print(PID+'dirold, dirnew if >4 ',dirold, dirnew)
    
    # Determine the new direction
    
    a.setDir(dirnew)
    print(PID+'New direction of actor ',name, ' is = ',dirnew)
    
    a.setOutputMessage('yesMove')
    print(PID+'actor ',name, 'wants to move')
    
    
        
 
    
def behaviorAcRand(e,a):
    
    import numpy as np
    import environment as env
    import acctor as acc
    
    #BODY PART
    # Compute time since last call and change energy level
    
    name = a.getName()
    
    #check for food-intake
    
    f = a.getIntake()
    if f > 0:
        eold = a.getEnergy()
        enew = eold + f
        a.setEnergy(enew)
        a.setIntake(0)      #Set value back to zero
        print(PID+'Actor ',name,' has  increased ENERGYLEVEL = ',enew)
    
    
    #Compute time
    t1 = a.getTime()
    t2 = e.getClock()
    erate = a.getEnergyRate()
    ener = a.getEnergy()
    
    dt = t2-t1
    energynew = ener - (erate * dt)
    a.setEnergy(energynew)
    
    print(PID+'Actor ',name,' has new energy level = ',energynew)
    
    #MENTAL PART
    # Determine the new direction
    
    dirspace = 4
    dirnew = np.random.randint(1,dirspace+1)
    a.setDir(dirnew)
    print(PID+'New direction of actor ',name, ' is = ',dirnew)
    
    a.setOutputMessage('yesMove')
    print(PID+'actor ',name, 'wants to move')
    
    
        
    