# -*- coding: utf-8 -*-
"""
Created on Mon Oct 16 08:19:31 2017
Last changes Fr Oct 20 17:08 2017

@author: gerd doeben-henisch
In this version of the program we have all three  behavior functiosn together.
You can select:

    - how many cycles the demo should run
    - which kind of behavior function you want to test
    
You have actually the following options:
    
0 := Empty behavior function (manually driven)
1 := fixed behavior function (turning always right-hand)
2 := random behavior function
"""

# Program: gdh-win21.py
   
#Print-Identifier
PID="MAIN:\n "

def main():
   import graphics as grph        #Graphics objects from Zelle
   import environment as env      #Functions to generate grids
   import numpy as np             #numerical library numpy
   import acctor as acc           #Acctor related functions
   import time as tm              #Timer library
   import control as ctrl         #Control windows library
   
   ##
   ## SET UP THE ENVIRONMENT
   ##

   
   #An object of class ENVOBJ
   #importanr parameters
   
   envname = 'env1'
   envclock = 0
   objtPerc = 20  #20 % of the area should be obstacles
   foodPerc = 1   #1% of the area should be food
   foodEnergy = 1000  #Amount of energy by intaking 1x food
   
   e1=env.ENVOBJ(envname,envclock, objtPerc,foodPerc,foodEnergy)
   
   #A graphics window
   
   xmax = 700
   ymax = 700
   
   #Window for environment with actors
   win = grph.GraphWin('ENVIRONMENT 1', xmax, ymax)
   win.setBackground('HoneyDew')
   
   first = 1    #First element of the list
   last = 7     # Last element of the list used
   distance = 100   #distance of two lines in the grid
   maxXcoord = 7  #size of the data array in the background
   maxYcoord = 7
   nobj = 20    #objects: percentage of the array space !
   nfood = 1    #food: percentage of the array space !
   
   #generating the lines of the grid
   
   env.grid(win,xmax, ymax, first, last, distance)
   
  # Fill the grid with spaces and objects
   gr2=env.fillgridobj2(win,first, last, maxXcoord,maxYcoord,nobj)
   
   # Fill the grid with food
   gr2=env.fillgridfood(win,first, last, maxXcoord,maxYcoord,nfood,gr2)
   
   # Starting the global environment time
   
   time=e1.getClock()  
   
   ##
   #Introducing a single actor
   ##
   #Window for interaction with user for parameters
   #Please point ti a cell in the Grid...
   
   winC, txt1 =ctrl.ctrlWinStart()
   
   #Get the array coordinates for the actor by clicking into the grid
   #Anounce the clicking
   #message = grph.Text(grph.Point(100, 15), "Click on one cell for the actor")
   #message.setTextColor('red')
   #message.draw(winC)

   # Get coordinate of the mouse-click as starting point
   p = win.getMouse()
   p.draw(win)
   xc=p.getX()
   yc=p.getY()
   print(PID+'P ',p,(xc,yc))
   
   #Delete Message
   
   ctrl.ctrlWinDel(txt1)
   
   #Transform the window coordinates into the array coordinates
   xs = int(xc/100)
   ys = int(yc/100) 
   x = xs+1
   y=ys+1
   print(PID+'Center Array  ',(x,y))
   
   #Insert the actor in the data array
   gr2[xs,ys]=3
   
   #Introduce more parameter for new actor object
   dir=1
   color = 'red'
   name="A1"
   energy=2000
   energyrate=2
   
   
   #Generate an instance of the actor class ACTOBJ
   a1=acc.ACTOBJ(name,time,x,y,dir,color, energy,energyrate)

   a1.setPos(x,y)  #Write actual position of actor into actor object
   outputMessage='yesMove'  #This tells the environment whether an actor
                           #wants to move
   a1.setOutputMessage(outputMessage)
   
   #Realize an actor on the window
   env.introduceActor(x,y,dir,name,color,energy,distance,win)
   
   print(PID+'MAP OF ARRAY \n')
   print(PID+str(gr2))
   print(PID+'ATTENTION: Columns represent Rows on screen!\n')
   
   txt3, txt5 = ctrl.ctrlWinEnergy(winC,energy,time)
   
   ##
   ## START AN EVENT LOOP FOR THE ENVIRONMENT
   ##
   ## ASK ACTOR-BEHAVIOR-FUNCTION WHAT TO DO
   ## CHECK WETHER ACTIONS WANTED ARE POSSIBLE
   ## MODIFY THE ENVIRONMENTR IF NECESSARY
   ## REPEAT AS LONG AS ACTORS ARE ALIVE
   ##
   cyclesNo, txt9 = ctrl.ctrlWinSelCylenumber(winC)
   
   # condition for while()
   FINISH= cyclesNo
   
   ctrl.ctrlWinDel(txt9)
   
   # Select behavior function {0-2}
   
   behaviorNo, txt8 = ctrl.ctrlWinSelBehave(winC)
   

   while FINISH >0:

    # Look to the actor class for new responses
    
    # The environment manager gets the informtion about the wanted direction
    # from the actor object. Because the actual actor has an empty behavior function 
    # the user has to write a new direction into the actor object. This will be done
    # by clicking on that neighbouring cell where the user wants the actor to move.
    # See below in the part of the actor behaviro function
    
    #Call the actor
    # The actor will compute it's response and will update the class
   
     if behaviorNo == 0:
        acc.behaviorAcEmpty(e1,a1,win,winC,txt8)
     elif behaviorNo == 1:
        acc.behaviorActFix(e1,a1)
     else:
        acc.behaviorAcRand(e1,a1)
    
     if a1.getOutputMessage() == 'yesMove':
    
    # If there are responses then compute the next possible move
    
        dirnew = a1.getDir()
        print(PID+'New Position planned = ',dirnew)
    
        #Check whether this new position  is possible
        #Computing new coordinates
        
        p=a1.getPos()
        print(PID+'Actual Position = ',p)
        xold=p[0]
        yold=p[1]
    
    #Compute the next possible move
    
        Err, xnew, ynew = env.newPosition(dirnew,xold,yold)
        
        if Err == -1:
            print(PID+'Err = ', Err)
        else:
            print(PID+'New Position planned = ', (xnew,ynew))
        
    
        if gr2[xnew-1,ynew-1] != 0:
            #Telling the actor that the planned new position is occupied
            a1.setInputMessage("NoMove")
            print(PID+'actor =',name,' has hit an obstacle at ',xnew,ynew)
            #REMARK: The actor is hitting food only if the food is in the
            #direction of his move!
            if gr2[xnew-1,ynew-1] == 2:
                print(PID+'actor =',name,' has hit FOOD')
                a1.setIntake(1000)
        else:
            type=3 #actor
            #First change position in data array
            print(PID+'actor =',name,' will move in Array',xnew,ynew)
            env.moveArray(type,xold,yold,xnew,ynew,gr2)
            #Tell the actor his new position
            a1.setPos(xnew,ynew)
            #Next change position in window
            print(PID+'Inserting actor at', xnew,ynew)
            env.introduceActor(xnew,ynew,dir,name,color,energy,distance,win)
            env.deleteActor(p,win)
            a1.setInputMessage('YesMove')
            print(PID+'actor =',name,' has moved')
     else:
        print(PID+'No move wanted by actor.')
        
        
     # Get the actual environment time
    
     t2=e1.getClock()
     print(PID+'Environment Time =', t2)
     
    #counting FINISH down for to stop after finitely many steps
     FINISH=FINISH-1
    
     envClock = e1.getClock()
     print(PID+'Actual Environment Time = ',envClock)
     envClock= envClock+1
     e1.setClock(envClock)
     print(PID+'New  Environment Time = ',envClock)
    
     energy=a1.getEnergy()
     if energy <0:
        print(PID+'ATTENTION: Actor ',name,' has no more Energy!!!')
        FINISH=-1
        
        
     #Refresh Energy and Time
     ctrl.ctrlWinDel(txt3)
     ctrl.ctrlWinDel(txt5)
     txt3, txt5 = ctrl.ctrlWinWrt(winC,energy,envClock)
     tm.sleep(1)

    #Continuation delayed by the timer functionm
     #tm.sleep(2) #python timer , sleep 5 secs
    
   
   print(PID+'THE GAME SAYS GOODBYE!')
   
   print(PID+'MAP OF ARRAY \n')
   print(PID+str(gr2))
   print(PID+'ATTENTION: Columns represent Rows on screen!\n')
    
   tm.sleep(10)
   winC.close()
   win.close()
main()
